/* -*-Mode: C++;-*-
 * PRCS - The Project Revision Control System
 * Copyright (C) 1997  Josh MacDonald
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: diff.h 1.3.1.5.1.5 Wed, 22 Jan 1997 12:02:00 -0800 jmacd $
 */


#ifndef _DIFF_H_
#define _DIFF_H_

class MergeCandidate {
public:
    MergeCandidate (ProjectVersionData *data0, bool is_working0);

    ProjectVersionData *_data;
    bool _is_working;
    ProjectVersionData *_common;
    int _common_distance;
};

void populate_tables(ProjectDescriptor*, FileTable*, FileTable*);

FileEntry* lookup_file(FileEntry*, FileTable*);
FileEntry* alt_lookup_file(FileEntry*, FileTable*);

void format_diff_label(FileEntry* fe, const char* name,
		       const char* version, Dstring* ds, ProjectDescriptor *project);

PrBoolError diff_pair(FileEntry* from,
		      FileEntry* to,
		      const char* from_file,
		      const char* to_file,
		      const char* to_version,
		      const char* from_version,
		      ProjectDescriptor *project);

bool any_names_differ(FileEntry* working, FileEntry* common, FileEntry* selected);

#endif
