/* -*- C -*- code produced by gperf version 2.1 (K&R C version) */
/* -- modified jmacd@cs.berkeley.edu */
/* Command-line: gperf -A -C -a -r -k1,9 -N is_builtin_keyword -H is_builtin_keyword_hash  */



#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 19
#define MIN_HASH_VALUE 8
#define MAX_HASH_VALUE 33
/*
   14 keywords
   26 is the maximum key range
*/

int
is_builtin_keyword_hash (register const char *str, register int len)
{
  static const unsigned char hash_table[] =
    {
     33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33,  9,  8, 33, 10, 33,
      2, 33, 33,  9, 33, 33, 33, 33, 33, 33,
      3, 33,  1, 15, 33, 33, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33,  6, 33, 33,
     33,  8, 33, 33, 33, 11, 33, 33, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 10, 33, 33,
     33, 33, 33, 33, 33, 33, 33, 33,
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 9:
        hval += hash_table[str[8]];
      case 8:
      case 7:
      case 6:
      case 5:
      case 4:
      case 3:
      case 2:
      case 1:
        hval += hash_table[str[0]];
    }
  return hval ;
}

const char *
is_builtin_keyword (register const char *str, register int len)
{

   const char * wordlist[] =
    {
      "", "", "", "", "", "", "", "", 
      "Format", 
      "Revision", 
      "Project", 
      "Id", 
      "", "", 
      "Date", 
      "Author", 
      "Basename", 
      "", "", "", 
      "ProjectDate", 
      "Source", 
      "", "", 
      "ProjectHeader", 
      "ProjectVersion", 
      "ProjectAuthor", 
      "", 
      "ProjectMajorVersion", 
      "", "", "", "", 
      "ProjectMinorVersion", 
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = is_builtin_keyword_hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register const char *s = wordlist[key];

          if (*s == *str && !strcmp (str + 1, s + 1))
            return s;
        }
    }
  return 0;
}
